Quassel IRC - Bug #1512

SQLite journal/concurrency issues: SqliteStorage::getBufferinfo(): received more then one Buffer!
01/30/2019 01:12 PM - mgorny

Status: New Start date: 01/30/2019
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Quassel Core Estimated time: 0.00 hour

Target version:
Version: 0.13.0 0S: Any

Description
Every few days, my core crashes with an error like:

2019-01-30 11:19:09 [Error] SqgliteStorage::getBufferInfo(): received more then one Buffer!
2019-01-30 11:19:09 [Error] Query: "SELECT bufferid, buffertype, groupid\nFROM buffer\nWH
ERE buffer.networkid = :networkid AND buffer.user

id = :userid AND buffer.buffercname = :buffercname"

2019-01-30 11:19:09 [Error] bound Values:

2019-01-30 11:19:09 [Error] 0 : cynede_afk
2019-01-30 11:19:09 [Error] 1 : 1
2019-01-30 11:19:09 [Error] 2 : 1
2019-01-30 11:19:09 [FATAL]
e.cpp, line 1176

ASSERT: "false" in file /home/mgorny/git/quassel/src/core/sqlitestorag

| have no clue why this would happen. s it possible that the database was corrupted as a result of earlier crashes?
Can we have some nicer behavior here? Is there a nice way to fix the database by hand?

Finally, can we enforce this via database constraints?

History

#1 - 02/07/2019 12:13 AM - digitalcircuit

- Subject changed from [Error] SqliteStorage:.getBufferinfo(): received more then one Buffer! to SQLite journal/concurrency issues:
SqliteStorage::getBufferinfo(): received more then one Buffer!

- Category set to Quassel Core

Details

| agree that this should be enforced by database constraints, that Quassel should handle this more gracefully, and I'm not sure how Quassel would
get into this state.

My guess is Quassel crashed in the middle of a write before it completed, or Quassel's current locking mechanism in SQLite allowed concurrent
writes. Based on the bound values, it seems like a private message buffer was renamed (either due to /nick changes, or manual action). To fix this
and other issues, Quassel likely needs to adopt SQLite's WAL mode , which had performance issues with older SQLite versions (e.g. as in Ubuntu
14.04). With 0.14/master increasing build requirements, this is something we can finally try to tackle.

Crashes once this inconsistency exists are likely merely periodic as it'd only occur when Quassel tries to get this buffer information, which may be
when a particular user logs in, etc.

Workaround/recovery
To recover, you should be able to find the duplicate buffer and rename it:
1. Find the IDs of the duplicate buffers, the ones with the same name/user ID/network ID

With the original query of...

SELECT bufferid, buffertype, groupid FROM buffer WHERE buffer.networkid = :networkid AND
buffer.userid = :userid AND buffer.buffercname = :buffercname;

...and the bound values of...
https://sqlite.org/wal.html

cynede_afk, 1, 1
This should be...

SELECT bufferid FROM buffer WHERE buffer.networkid = 1 AND buffer.userid = 1 AND buffer.buffercname = '
cynede_afk"';

2. Rename one of the buffers to avoid the collision
Make a backup first! I'm not 100% certain this will fix the issue.
Rename the buffercname and buffername of the problematic buffer to a unique name...

UPDATE buffer SET buffercname = 'cynede_afk_dup', buffername = 'cynede_afk_dup' WHERE bufferid = XXXX;
—— Replace XXXX with one of the buffer ID numbers from above

Retry the query in step 1. If there's still more results, repeat this, but pick different names for buffercname and buffername, e.g. cynede_afk_dup2.

#2 - 02/07/2019 08:12 AM - mgorny

Thank you. I've just applied the recovery and we'll see what happens now. It turned out that “cynede_afk™ had two duplicates with very different
numbers (one 1xx, other 4xx), so | suspect this might have been going for some time already. Though | suspect | never knew because | haven't been
running debug builds before.

#3 - 02/14/2019 05:48 AM - digitalcircuit

Thanks for feedback; I'm glad the recovery worked! That does seem odd, and given the assert() only on debug builds, it's a relief it's likely not a new
issue/regression.

Quassel should still handle this better, as originally agreed.

Pardon my delayed reply; turns out | need to manually watch an issue after commenting in order to get email notifications.

#4 - 03/31/2019 07:15 PM - mgorny

It happened to me today, and it seems that there is some deeper issue that is causing those duplicate buffers to occur.

More specifically, | received messages from '<person>', and after applying the deduplication as explained above, the <person>_dup buffer contained

only the messages received today. If that's of any help, the messages were described as '<person>1', so | think the person in question may have
changed the nickname just after writing.

#5 - 10/03/2022 02:17 PM - Luminair
digitalcircuit wrote:

With 0.14/master increasing build requirements, this is something we can finally try to tackle.
It lives! | just got this on Synology DS920+ AMDG64 Iscr.io/linuxserver/quassel-core:0.14.0-Is100. The system slowed down while downloading a file
quickly and then the Quassel container stopped working. | attempted sqlite3 dump and vacuum to no effect. | don't have the skill do attempt digging
into the database to attempt a workaround unless you have a precise suggestion :P

2022-10-03 09:03:35 [Info ] Restoring previous core state...

2022-10-03 09:03:35 [Error] SgliteStorage::getBufferInfo(): received more then one Buffer!
2022-10-03 09:03:35 [Error] Query: "SELECT bufferid, buffertype, groupid\nFROM buffer\nWHERE buffer.n
etworkid = :networkid AND buffer.userid = :userid AND buffer.buffercname = :buffercname"

2022-10-03 09:03:35 [Error] bound Values:
2022-10-03 09:03:35 [Error] 0 :

2022-10-03 09:03:35 [Error] 1 : 1
2022-10-03 09:03:35 [Error] 2 : 2

2022-10-03 09:03:36 [Error] SgliteStorage::getBufferInfo(): received more then one Buffer!
2022-10-03 09:03:36 [Error] Query: "SELECT bufferid, buffertype, groupid\nFROM buffer\nWHERE buffer.n
etworkid = :networkid AND buffer.userid = :userid AND buffer.buffercname = :buffercname"

2022-10-03 09:03:36 [Error] bound Values:

2022-10-03 09:03:36 [Error] O :

2022-10-03 09:03:36 [Error] 1 : 1

2022-10-03 09:03:36 [Error] 2 : 2

2022-10-03 09:03:36 [Error] SgliteStorage::getBufferInfo(): received more then one Buffer!

#6 - 10/20/2022 05:54 PM - Luminair

The database got corrupted again after another shutdown. | believe | captured the log before and after the shutdown. | hope this helps!

quassel-core
date stream content
2022-10-20T04:30:27.1497073082 stderr
2022-10-20T04:30:16.0797205152 stderr
2022-10-20T04:30:16.0796726772 stderr

0.0 port 4242 using protocol version 10
2022-10-20T04:30:16.07963464972 stderr
ort 4242 using protocol version 10

2022-10-20T04:30:16.0796036827 stderr
2022-10-20T04:30:16.0795673302 stderr
a version: 32
2022-10-20T04:30:16.0795029547 stderr
Nov 23 00:35:19 2021 GMT"
2022-10-20T04:30:15.7348942302 stderr
Nov 23 00:35:19 2021 GMT"
2022-10-20T04:30:14.26470198472 stderr
2022-10-20T04:30:14.264443379Z stdout
2022-10-20T04:30:14.263123852%2 stderr
2022-10-20T04:30:14.2629802052 stderr
2022-10-20T04:30:14.25910846272 stderr
tification)
2022-10-20T04:30:14.2334646547 stderr
2022-10-20T04:30:14.2333615952 stderr
2022-10-20T04:30:14.232457828%2 stderr
2022-10-20T04:30:14.2323503032 stderr
2022-10-20T04:30:14.2314229072Z stderr
2022-10-20T04:30:14.2312616627%2 stderr
d

2022-10-20T04:30:14.2249609247 stderr
2022-10-20T04:30:14.224780053%2 stderr
2022-10-20T04:30:14.2237927292 stderr
2022-10-20T04:30:14.2236701012Z stderr
2022-10-20T04:30:14.2233066967 stderr
2022-10-20T04:30:14.2203549802 stdout
2022-10-20T04:30:14.216367739% stderr
2022-10-20T04:30:14.216278602%2 stderr
2022-10-20T04:30:14.180257486%2 stderr
2022-10-20T04:30:14.1801301342 stderr
2022-10-20T04:30:14.1285665372 stderr
2022-10-20T04:30:14.12841991472 stderr
2022-10-20T04:30:14.075731934%2 stdout
2022-10-20T04:30:14.0757046572 stdout
2022-10-20T04:30:14.0756592662 stdout
2022-10-20T04:30:14.0756241847 stdout
2022-10-20T04:30:14.0663793592 stdout
2022-10-20T04:30:14.06635422672 stdout
2022-10-20T04:30:14.0663303152 stdout
2022-10-20T04:30:14.0663017432 stdout
2022-10-20T04:30:14.0662703522 stdout
2022-10-20T04:30:14.0662477012Z stdout
2022-10-20T04:30:14.0662217962 stdout
2022-10-20T04:30:14.0661934092 stdout
2022-10-20T04:30:14.0661711652 stdout
2022-10-20T04:30:14.0661477672 stdout
2022-10-20T04:30:14.0661199762 stdout
2022-10-20T04:30:14.06609548272 stdout
2022-10-20T04:30:14.0660691687 stdout
2022-10-20T04:30:14.0660375502 stdout
2022-10-20T04:30:14.0660103592 stdout
2022-10-20T04:30:14.06598294672 stdout
2022-10-20T04:30:14.0659534247 stdout
2022-10-20T04:30:14.065743335%2 stdout
2022-10-20T04:30:13.9017667977 stderr
2022-10-20T04:30:13.9017202192 stderr
2022-10-20T04:30:13.9016631742 stdout
2022-10-20T04:30:13.9015728572 stdout
2022-10-20T04:30:13.8998896042 stderr
2022-10-20T04:30:13.89975355472 stderr
2022-10-20T04:30:13.89596698472 stderr
2022-10-20T04:30:13.8933945272 stderr
2022-10-20T04:30:13.8932426562 stderr
2022-10-20T04:30:13.8913383327 stderr
2022-10-20T04:30:13.8889186272 stderr
2022-10-20T04:30:13.8888481997 stderr
2022-10-20T04:30:13.8875123977 stderr
2022-10-20T04:30:13.8819043752 stderr
2022-10-20T04:30:13.5764406572 stdout
2022-10-20 01:
2022-10-20 01:
2022-10-20 01:
2022-10-20 01:

2022-10-20 01:
2022-10-20 01:

2022-10-20 01:

2022-10-20 01

30:27 [Info ] Client connected from 172.18.0.1
30:15 [Info ] Restoring previous core state...
30:15 [Info ] Listening for GUI clients on IPv4 0.0.
30:15 [Info ] Listening for GUI clients on IPv6 :: p
30:15 [Info ] Database authenticator is ready.
30:15 [Info ] SQLite storage backend is ready. Schem
30:15 [Warn ] SslServer: Certificate expired on "Tue
:30:15 [Warn ] SslServer: Certificate expired on "Tue

s6é-rc: info: service 99-ci-service-check successfully started
[ls.io-init] done.

s6-rc: info: service 99-ci-service-check: starting

s6é-rc: info: service legacy-services successfully started
services-up: info: copying legacy longrun quassel (no readiness no
s6-rc: info: service legacy-services: starting

s6-rc: info: service init-services successfully started

s6-rc: info: service init-services: starting

s6é-rc: info: service init-mods-end successfully started

s6-rc: info: service init-mods-end: starting

s6-rc: info: service init-mods-package-install successfully starte
s6-rc: info: service init-mods-package-install: starting

s6-rc: info: service init-mods successfully started

s6é-rc: info: service init-mods: starting

s6-rc: info: service legacy-cont-init successfully started
cont-init: info: /etc/cont-init.d/99-custom-files exited 0

"[custom—-init

] No custom files found, skipping..."

cont-init: info: running /etc/cont-init.d/99-custom-files
cont—init: info: /etc/cont-init.d/40-config exited 0
cont-init: info: running /etc/cont-init.d/40-config
cont-init: info: /etc/cont-init.d/30-keygen exited 0
cont-init: info: running /etc/cont-init.d/30-keygen
cont-init: info: /etc/cont-init.d/10-adduser exited 0
User gid: 101

User uid: 1026

GID/UID
usermod: no changes
cont—init: info: running /etc/cont-init.d/l10-adduser
cont-init: info: /etc/cont-init.d/0l-migrations exited 0

[migrations]
[migrations]

no migrations found
started

cont-init: info: running /etc/cont-init.d/0Ol-migrations
cont-init: info: /etc/cont-init.d/0Ol-envfile exited O
cont—init: info: running /etc/cont-init.d/0l-envfile
s6é-rc: info: service legacy-cont-init: starting

s6-rc: info: service fix-attrs successfully started
s6-rc: info: service 00-legacy successfully started
s6-rc: info: service 00-legacy: starting

s6-rc: info: service fix-attrs: starting

s6-rc: info: service sé6rc-oneshot-runner successfully started
s6é-rc: info: service sérc-oneshot-runner: starting
"[custom-init] No custom services found, skipping..."
#7 - 11/24/2022 04:00 AM - Luminair

I've developed some new info about my database failures:

stderr

stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr

stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr
stderr

"2022-10-20 01:27:16

2022-10-20 01:27:16

s6-rc:
s6-rc:
B6=re’
s6-rc:
s6-rc:
B6=re’
s6-rc:
s6-rc:
B6=re’

s6-rc:
B6=re’
s6-rc:
s6-rc:
B6=re’
s6-rc:
s6-rc:
B6=re’

info:
info:
info:
info:
info:
info:
info:
info:
info:

info:
info:
info:
info:
info:
info:
info:
info:
fatal:

sb-svwait:
2022-10-20 01:27:13
2022-10-20 01:27:13
2022-10-20 01:27:13

s6-rc:
B6=re’
s6-rc:

info:
info:
info:

service
service
service
service
service
service
service
service
service

service
service
service
service
service
service
service
service

service
service
service

[Info ] Already shutting down, ignoring signa

[Info ] Caught signal 15

sérc-oneshot-runner successfully stopped
sérc-oneshot-runner: stopping

fix-attrs successfully stopped

fix—-attrs: stopping

legacy-cont-init successfully stopped
legacy-cont-init: stopping

init-mods successfully stopped

init-mods: stopping

init-mods-package-install successfully stoppe

init-mods-package-install: stopping
init-mods-end successfully stopped
00-legacy successfully stopped
init-mods-end: stopping
init-services successfully stopped
00-legacy: stopping

init-services: stopping
legacy-services successfully stopped

timed out

[Info ] Core shutting down...

[Info ] Quitting...

[Info ] Caught signal 15

legacy-services: stopping
99-ci-service-check successfully stopped
99-ci-service-check: stopping

1) Docker apparently uses SIGTERM to stop apps, and Quasselcore apparently doesn't handle that, which then leads to a chance of corrupting the
database every time Docker closes Quassel. The workaround I'm trying is "stop_signal: SIGINT", equal to a Ctrl+C, which Quassel does handle.

2) Quassel database is unpredictably inconsistent and there is no system/API in place to tell it to BECOME consistent before a backup or filesystem
snapshot. So this caused my backups to fail, too. The workaround for doing a backup will be to gracefully shut down Quasselcore, do the backup,
then start it up again.

Thoughts?
